/*
 * Initial main.c file generated by Glade. Edit as required.
 * Glade will not overwrite this file.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>

#include <gnome.h>
#include <glib.h>

#include <panel-applet.h>
#include <gst/gst.h>
#include "interface.h"
#include "support.h"
#include "common.h"

#if !defined(GNOMELOCALEDIR)
#define GNOMELOCALEDIR PACKAGE_LOCALE_DIR
#endif

#define GLADE_HOOKUP_OBJECT(component,widget,name) \
  g_object_set_data_full (G_OBJECT (component), name, \
    gtk_widget_ref (widget), (GDestroyNotify) gtk_widget_unref)

#define GLADE_HOOKUP_OBJECT_NO_REF(component,widget,name) \
  g_object_set_data (G_OBJECT (component), name, widget)

gint target_tag;
GThread *ui_thread;
GThread *tcp_thread;
udp_con_t *udp_con;


void
read_message(gpointer data,
	     gint source,
	     GdkInputCondition condition) {
  char *msg_buff=NULL;
  size_t len;
  
  gdk_input_remove(target_tag);
  len=0;
  msg_buff=NULL;
  udp_recv_message(udp_con,&msg_buff,&len);
      if (len>0) {
	msg_data_t msg;

	init_message_data(&msg);
	dbg_out("Message arrive\n");
	parse_message(&msg,msg_buff,len);
	free(msg_buff);
	msg_buff=NULL;
	ipmsg_dispatch_message(udp_con,&msg);
	release_message_data(&msg);
      }
  dbg_out("Add socket:%d\n",udp_con->soc);
  target_tag=gdk_input_add(udp_con->soc,GDK_INPUT_READ,read_message,NULL);
}

gpointer    
ipmsg_ui_thread(gpointer data){
#if !defined(G2IPMSG_APPLET)
  GtkWidget *initialWindow;
  GtkWidget *startBtn;
#endif
  udp_con_t con;


  /*
   * The following code was added by Glade to create one of each component
   * (except popup menus), just so that you see something after building
   * the project. Delete any components that you don't want shown initially.
   */

  logfile_init_logfile();
  init_message_info_manager();
  memset(&con,0,sizeof(con));
  udp_setup_server(&con,hostinfo_refer_ipmsg_port());
  udp_enable_broadcast(&con);

  udp_con=&con;

#if !defined(G2IPMSG_APPLET)
  initialWindow = create_initialWindow ();
  startBtn=lookup_widget(initialWindow,"startBtn");
  gtk_widget_set_events (startBtn,GDK_BUTTON_PRESS_MASK);
  gtk_widget_show (initialWindow);
#endif

  dbg_out("Add socket:%d\n",udp_con->soc);
  target_tag=gdk_input_add(udp_con->soc,GDK_INPUT_READ,read_message,NULL);
  ipmsg_send_br_entry(udp_con,hostinfo_get_normal_send_flags());
  init_sound_system(PACKAGE);
  gtk_main ();
  logfile_shutdown_logfile();
  hostinfo_cleanup_hostinfo();
  dbg_out("UI Thread ended\n");
  cleanup_sound_system();

  return (gpointer)0;
}

static int
g2ipmsg_main (int argc, char *argv[])
{

  gst_init (NULL, NULL);

#ifdef ENABLE_NLS
  bindtextdomain (GETTEXT_PACKAGE, PACKAGE_LOCALE_DIR);
  bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
  textdomain (GETTEXT_PACKAGE);
#endif
#if !defined(G2IPMSG_APPLET)
  gnome_program_init (PACKAGE, VERSION, LIBGNOMEUI_MODULE,
                      argc, argv,
                      GNOME_PARAM_APP_DATADIR, PACKAGE_DATA_DIR,
                      NULL);
#endif
  hostinfo_init_hostinfo();
  ui_thread=g_thread_create(ipmsg_ui_thread,
				    NULL,
				    TRUE,
				    NULL);
  tcp_thread=g_thread_create(ipmsg_tcp_server_thread,
			       NULL,
			       FALSE,
			       NULL);
  g_thread_join (ui_thread);
    //    g_thread_join (tcp_thread);

  return 0;
}
#if defined(G2IPMSG_APPLET)
static BonoboObject *
g2ipmsg_applet_fill (PanelApplet *applet,
		   const gchar *iid,
		   gpointer     data)
{
  GtkWidget *startBtn;
  GtkWidget *image3;
  int fake_argc;
  char *fake_argv[]={PACKAGE,};

 if (strcmp (iid, "OAFIID:G2ipmsg") != 0)
   return FALSE;

  g_assert(applet);

  startBtn = gtk_button_new ();
  gtk_widget_show (startBtn);

  gtk_container_add (GTK_CONTAINER (applet), startBtn);

  image3 = create_pixmap (applet, "g2ipmsg/ipmsg.xpm");
  gtk_widget_show (image3);
  gtk_container_add (GTK_CONTAINER (startBtn), image3);

  g_signal_connect ((gpointer) startBtn, "clicked",
                    G_CALLBACK (on_startBtn_clicked),
                    NULL);

  gtk_widget_set_events (startBtn,GDK_BUTTON_PRESS_MASK);


  /* Store pointers to all widgets, for use by lookup_widget(). */
  GLADE_HOOKUP_OBJECT_NO_REF (applet, applet, "initialWindow");
  GLADE_HOOKUP_OBJECT (applet, startBtn, "startBtn");
  GLADE_HOOKUP_OBJECT (applet, image3, "image3");

  gtk_widget_show(applet);

  g2ipmsg_main(fake_argc,fake_argv);

  return TRUE;
}
#endif
#if !defined(G2IPMSG_APPLET)
int 
main(int argc, char *argv[]){
  return g2ipmsg_main(argc,argv);
}
#else
PANEL_APPLET_BONOBO_FACTORY ("OAFIID:G2ipmsg_Factory",
                             PANEL_TYPE_APPLET,
                             "G2ipmsg Applet",
                             "0.1",
                             g2ipmsg_applet_fill,
                             NULL);
#endif
