#if !defined(UDP_H)
#define UDP_H

typedef struct _udp_con{
  int soc;
  int port;
  struct sockaddr_in server;
  struct sockaddr_in client;
}udp_con_t;
int internal_realloc(void **ptr,size_t new_size,size_t old_size);

int udp_setup_client(const char *hostname, int port,udp_con_t *con);
int udp_setup_server(udp_con_t *con,int port);
int udp_send_message(const udp_con_t *con,const char *ipaddr,int port, const char *msg,size_t len);
int udp_send_peer(const udp_con_t *con,const char *msg,size_t len);
int udp_send_broadcast_with_addr(const udp_con_t *con,const char *bcast,const char *msg,size_t len);
int udp_send_broadcast(const udp_con_t *con,const char *msg,size_t len);
int udp_is_message_arrive(const udp_con_t *con,unsigned long tmout);
int udp_enable_broadcast(const udp_con_t *con);
int udp_disable_broadcast(const udp_con_t *con);
int udp_recv_message(const udp_con_t *con,char **msg,size_t *len);
int udp_recv_message_full(const udp_con_t *con,char **msg,size_t *len);
#endif
